<?php
class ManifestAjax extends ManifestRepository
{
    public $status_manifest = null;
    public function __construct()
    {
        parent::__construct();
    }

    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }

    public function setManifestDetalles(array $options)
    {
        $data = array();
        foreach ($options['options'] as $row) {
            $data[$row['name']] = $row['value'];
        }
        
        $this->status_manifest = $data['status'];
        $options = $data;
        $producto = $this->getProductoById($options['id_product']);
        if ($producto) {
            $data = array(
                'token_form'=>$options['token_form'],
                'idDetalleTemp'=>$options['idDetalleTemp'],
                'id_manifest'=>$options['id_manifest'],
                'id_product'=>$producto['id'],
                'descripcion'=>$producto['descripcion'],
                'id_variety'=>$options['id_variety'],
                'id_madurity'=>$options['id_madurity'],
                'id_size'=>$options['id_size'],
                'id_packing'=>$options['id_packing'],
                'id_brand'=>$options['id_brand'],
                'id_quality'=>$options['id_quality'],
                'id_color'=>$options['id_color'],
                'weight'=>$options['weight'],
                'quantity_boxes'=>$options['quantity_boxes'],
                'cost'=>$options['cost'],
                'quantity_boxes_per_pallets'=>$options['quantity_boxes_per_pallets'],
                'quantity_pallets'=>$options['quantity_pallets'],
                'mixto'=>$options['mixto']);
            
            $this->insertDetalle($data);
            $manifestDetalles = $this->getManifestDetalles($data['token_form']);
            $detalles = $this->listManifestDetalles($manifestDetalles);
            $manifestDetallesMixto = null;
            $detallesMixto = null;
            
            if ($options['mixto'] !== '0' || $options['mixto'] !== null) {
                $manifestDetallesMixto = $this->getManifestDetallesByMixto($options['mixto'], $data['token_form']);
                $detallesMixto = $this->listManifestDetallesMixto($manifestDetallesMixto);
            }

            $json = array(
                'response' => true,
                'manifestDetalles' => $detalles['listDetalles'],
                'manifestSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'costoTotal'=>$detalles['costoTotal'],
                'manifestDetallesMixto' => $detallesMixto['listDetalles'],
                'cajasTotalMixto' => $detallesMixto['cajasTotal'],
                'pesoTotalMixto' => $detallesMixto['pesoTotal'],
                'costoTotalMixto' => $detallesMixto['costoTotal'],
            );

            return $json;
        } else {
            $this->flashmessenger->addMessage(array('info'=>$this->_getTranslation('Producto no registrado.')));
            return $json = array(
                'response'=>null,
                'message'=>$this->flashmessenger->getMessageString());
        }
    }
    
    public function listManifestDetalles($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $palletsTotal = 0;
        $pesoTotal = 0;
        $sumaCostoTotal = 0;
        $sumaPesoTotal = 0;
        $tokenForm = null;
        
        foreach ($detalles as $detalle) {
            $tokenForm = $detalle['token_form'];
            $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
            $array = json_encode($detalle);
            $cajasTotal += $detalle['quantity_boxes'];
            $palletsTotal += $detalle['quantity_pallets'];
            $sumaPesoTotal += $detalle['weight_total'];
            $sumaCostoTotal += $detalle['cost_total'];
            
            $descripcion = str_replace(',', "<br>", $detalle['descripcion']);
            $variety = str_replace(',', "<br>", $detalle['varietyName']);
            $size = str_replace(',', "<br>", $detalle['sizeName']);
            $packing = str_replace(',', "<br>", $detalle['packingName']);
            $quality = str_replace(',', "<br>", $detalle['qualityName']);
            $color = str_replace(',', "<br>", $detalle['colorName']);
            $weight = str_replace(',', "<br>", $detalle['weight_concat']);
            $boxesQuantity = str_replace(',', "<br>", $detalle['quantity_boxes_concat']);
            $palletsQuantity = str_replace(',', "<br>", $detalle['quantity_pallets_concat']);
            $cost = str_replace(',', "<br>", $detalle['cost_concat']);
            
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                . "<td class='text-center'>                       
                    <a class='btn btn-sm btn-default' onclick='setDetalleManifestToEdit($array,this);' data-mixto='{$detalle['mixto']}' data-controller='Manifest'><i class='fa fa-pencil'></i></a>";
                    
            if ($this->status_manifest == '1' || $this->status_manifest == null) {
                $listDetalles .= "<a class='btn btn-sm btn-danger' onclick='deleteManifestDetalles($id);'><i class='fa fa-trash'></i></a>";
            }
            
            $listDetalles .= "</td>  "
                ."<td class='text-center'>".$detalle['id_pallet']."</td>"
                ."<td class='text-center'><input name='vendor_tag_number|{$detalle['id_pallet']}' type='text' value='{$detalle['vendor_tag_number']}' class='_customerTagNumber' style='width:100px' /></td>"
                ."<td class='text-center'><input name='pallet_temperature|{$detalle['id_pallet']}' type='text' value='{$detalle['pallet_temperature']}' class='_customerTagNumber _maskDouble' style='width:50px' /></td>"
                ."<td class='text-center'>".$descripcion."</td>"
                ."<td class='text-center'>".$variety."</td>"
                ."<td class='text-center'>".$size."</td>"
                ."<td class='text-center'>".$packing."</td>"
                ."<td class='text-center'>".$quality."</td>"
                ."<td class='text-center'>".$color."</td>"
                ."<td class='text-right'>".$weight."</td>"
                ."<td class='text-right'>".$boxesQuantity."</td>"
                ."<td class='text-right'>".$cost."</td>"
                ."<td class='text-right'>".number_format($detalle['cost_total'], 2)."</td>"
                ."</tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'listSummary'=>$this->listManifestSummary($tokenForm),
                     'cajasTotal'=>$cajasTotal,
                     'palletsTotal'=>$palletsTotal,
                     'pesoTotal'=>$sumaPesoTotal,
                     'costoTotal'=>$sumaCostoTotal);
    }
    
    public function listManifestSummary($tokenForm)
    {
        $summary = $this->getManifestSummary($tokenForm);
        $listSummary = null;
        foreach ($summary as $detalle) {
            $total = $detalle['quantity_boxes'] * $detalle['cost'];
            $listSummary .= "<tr>"
                ."<td class='text-center'>".$detalle['descripcion']."</td>"
                ."<td class='text-center'>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['packingName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-center'>".$detalle['colorName']."</td>"
                ."<td class='text-right'>".$detalle['weight']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."<td class='text-right'>".$detalle['quantity_pallets']."</td>"
                ."<td class='col-md-1 text-right'><input type='text' name='{$detalle['product_key_cost']}' data-keyproductcost='{$detalle['product_key_cost']}' value='{$detalle['cost']}' class='form-control _costByProductKeyCost _maskDouble' style='width:100%;text-align:right' /></td>"
                ."<td class='text-right'>".number_format($total, 2)."</td>"
                ."</tr>";
        }
        
        return $listSummary;
    }
    
    public function getListManifestDetalles($tokenForm)
    {
        $manifestDetalles = $this->getManifestDetalles($tokenForm);
        $detalles = $this->listManifestDetalles($manifestDetalles);

        $json = array(
                'response' => true,
                'manifestDetalles' => $detalles['listDetalles'],
                'manifestSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'costoTotal'=>$detalles['costoTotal']
            );
        return $json;
    }

    public function deleteDetalles(array $options)
    {
        $id = $options['id'];
        $repository = new ManifestDetailsTempRepository();
        $data = $repository->getById($id);
        
        if ($data['mixto']!=='0') {
            $result = $repository->deleteDetalleByMixto($data['mixto'], $data['token_form']);
        } else {
            $result = $repository->delete($id);
        }
        
        if ($result) {
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $manifestDetalles = $this->getManifestDetalles($data['token_form']);
        $detalles = $this->listManifestDetalles($manifestDetalles);
        
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'manifestDetalles'=>$detalles['listDetalles'],
                'manifestSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'costoTotal'=>$detalles['costoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
            );
        return $json;
    }
    
    public function listManifestDetallesMixto($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $pesoTotal = 0;
        $sumaPesoTotal = 0;
        $sumaCostoTotal = 0;
        
        foreach ($detalles as $detalle) {
            $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
            $array = json_encode($detalle);
            $cajasTotal += $detalle['quantity_boxes'];
            $sumaPesoTotal += $detalle['weight'];
            $sumaCostoTotal += $detalle['cost'];
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                . "<td class='text-left'>                       
                    <a class='btn btn-xs btn-default' onclick='setDetalleManifestToEditMixto($array);'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-xs btn-danger' onclick='deleteManifestDetallesMixto($id);'><i class='fa fa-trash'></i></a>
                </td>  "
                ."<td class='text-center'>".$detalle['descripcion']."<br/>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['brandName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."</tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'cajasTotal'=>$cajasTotal,
                     'pesoTotal'=>$sumaPesoTotal,
                     'costoTotal'=>$sumaCostoTotal);
    }
    
    public function getListManifestDetallesMixto($options)
    {
        $manifestDetallesMixto = $this->getManifestDetallesByMixto($options['mixto'], $options['token_form']);
        $detallesMixto = $this->listManifestDetallesMixto($manifestDetallesMixto);
        
        $json = array(
            'response' => true,
            'manifestDetallesMixto' => $detallesMixto['listDetalles'],
            'cajasTotalMixto' => $detallesMixto['cajasTotal'],
            'pesoTotalMixto' => $detallesMixto['pesoTotal'],
            'costoTotalMixto' => $detallesMixto['costoTotal'],
        );
        
        return $json;
    }
    
    public function deleteDetallesMixto(array $options)
    {
        $id = $options['id'];
        $repository = new ManifestDetailsTempRepository();
        $currentData = $repository->getById($id);
        $tokenForm = $currentData['token_form'];
        
        if ($repository->delete($id)) {
            $repository->assignMainProductForMixto($currentData['mixto'], $tokenForm);
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $manifestDetalles = $this->getManifestDetalles($tokenForm);
        $detalles = $this->listManifestDetalles($manifestDetalles);
        
        $dataMixto = $this->getListManifestDetallesMixto(array('mixto'=>$currentData['mixto'],'token_form'=>$currentData['token_form']));
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'manifestDetalles'=>$detalles['listDetalles'],
                'manifestSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'costoTotal'=>$detalles['costoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'manifestDetallesMixto' => $dataMixto['manifestDetallesMixto'],
                'cajasTotalMixto' => $dataMixto['cajasTotalMixto'],
                'pesoTotalMixto' => $dataMixto['pesoTotalMixto'],
                'costoTotalMixto' => $dataMixto['costoTotalMixto'],
            );
        return $json;
    }
    
    public function updateVendorTagNumberOrigin($options)
    {
        if (!isset($options['vendor_tag_number'])) {
            return array('response'=>true);
        }
        $tokenForm = $options['token_form'];
        $data = array();
        foreach ($options['vendor_tag_number'] as $row) {
            $data[$row['name']] = $row['value'];
        }
       
        $repository = new ManifestDetailsTempRepository();
        foreach ($data as $palletId => $tagNumber) {
            parent::query("UPDATE ".$repository->getTableName()." SET vendor_tag_number = '$tagNumber' WHERE id_pallet = '$palletId' AND token_form = '$tokenForm'");
        }
        
        return array(
            'response'=>true
        );
    }
    
    public function updateVendorTagNumber($options)
    {
        if (!isset($options['vendor_tag_number'])) {
            return array('response'=>true);
        }
        $tokenForm = $options['token_form'];
        $data = array();
        foreach ($options['vendor_tag_number'] as $row) {
            $data[$row['name']] = $row['value'];
        }
       
        $dataUpdate = array();
        foreach ($data as $key => $value) {
            $key = explode('|', $key);
            $dataUpdate[$key[1]][$key[0]] = $value;
        }

        $repository = new ManifestDetailsTempRepository();
        foreach ($dataUpdate as $palletId => $values) {
            $stringSet = null;
            foreach ($values as $field => $value) {
                if ($value == '_NULL' || is_null($value) || trim($value)=='') {
                    $stringSet .= "$field = NULL,";
                } else {
                    $stringSet .= "$field = '$value',";
                }
            }
            
            $stringSet = trim($stringSet, ',');
            parent::query("UPDATE ".$repository->getTableName()." SET $stringSet WHERE id_pallet = '$palletId' AND token_form = '$tokenForm'");
        }
        
        return array(
            'response'=>true
        );
    }
    
    public function updatePurchaseCostByProductKeyCost($options)
    {
        $manifestDetailsTempRepo = new ManifestDetailsTempRepository();
        $manifestDetailsTempRepo->updateCostByProductKeyCost($options);
        
        return $this->getListManifestDetalles($options['tokenForm']);
    }
    
    public function listManifestVsReceived($tokenForm)
    {
        $listSummary = null;
        $cajasTotal = 0;
        $palletsTotal = 0;
        $summary = $this->getShippingSummary($tokenForm);
        
        $shippingRequestRepo = new ShippingRequestRepository();
        $summaryShippingRequest = $shippingRequestRepo->getShippingRequestSavedSummary($this->idShippingRequest);

        $arrayMerge = array_merge($summaryShippingRequest, $summary);
       
        foreach ($arrayMerge as $keyproduct => $detalle) {
            $tr_class = null;
            $requestBoxes = 0;
            $requestPallets = 0;
            $shippingBoxes = 0;
            $shippingPallets = 0;
           
            if (key_exists($keyproduct, $summary)) {
                $shippingBoxes = $summary[$keyproduct]['quantity_boxes'];
                $shippingPallets = $summary[$keyproduct]['quantity_pallets'];
            }
            
            if (key_exists($keyproduct, $summaryShippingRequest)) {
                $requestBoxes = $summaryShippingRequest[$keyproduct]['quantity_boxes'];
                $requestPallets = $summaryShippingRequest[$keyproduct]['quantity_pallets'];
            } else {
                $tr_class = 'danger';
            }
            
            if ($tr_class == null) {
                if ($requestBoxes != $shippingBoxes) {
                    $tr_class = 'warning';
                } else {
                    $tr_class = 'success';
                }
            }
            
            $cajasTotal += $requestBoxes;
            $palletsTotal += $requestPallets;
            
            $listSummary .= "<tr class='$tr_class'>"
                ."<td class='text-center'>".$detalle['descripcion']."</td>"
                ."<td class='text-center'>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['packingName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-center'>".$detalle['colorName']."</td>"
                ."<td class='text-right'>".$detalle['weight']."</td>"
                ."<td class='text-right'>".$requestBoxes."</td>"
                ."<td class='text-right'>".$requestPallets."</td>"
                ."<td class='text-right'>".$shippingBoxes."</td>"
                ."<td class='text-right'>".$shippingPallets."</td>"
                ."</tr>";
        }
        
        return array(
            'listSummary'=>$listSummary,
            'total_boxes'=>$cajasTotal,
            'total_pallets'=>$palletsTotal
        );
    }
    
    public function replaceMDWithRD($options)
    {
        $this->_replaceMDWithRD($options['manifest_id']);
        
        return array(
            'response'=>true,
        );
    }
    
    public function replaceMDWithOD($options)
    {
        $this->_replaceMDWithOD($options['manifest_id']);
        
        return array(
            'response'=>true,
        );
    }
    
    public function getVendorMethodPayment($options)
    {
        $vendor = $options['vendor'];
        $date = $options['date'];
        $dueDate = $date;
        
        $repoVendor = new VendorRepository();
        $dataVendor = $repoVendor->getById($vendor);
        
        $paymentTermsRepo = new PaymentTermsRepository();
        $paymentTermsData = $paymentTermsRepo->getById($dataVendor['payment_terms']);
        
        if ($date !== '' && !is_null($date)) {
            $tools = new Tools();
            $date = $tools->setFormatDateToDB($date);
            
            $dueDate = $this->getDueDate($date, $paymentTermsData['days']);
            $dueDate = $tools->setFormatDateToForm($dueDate);
        }
        
        return array(
            'response'=>true,
            'payment_terms'=>$paymentTermsData['id'],
            'due_date'=>$dueDate
        );
    }
    
    public function setFormAddProductToManifest($options)
    {
        $controller = $options['controller'];
        $mixto = $options['mixto'];
        $tokenForm = $options['token_form'];
        $consecutivoPallet = '0';
        
        $form = new ManifiestoAgregarProductoForm();
        if ($mixto === '0'|| $mixto === null) {
            $stringForm = "<div class='col-md-12 col-xs-12'>";
            $stringForm .= $form->getModalFormString($controller, $tokenForm);
            $stringForm .= "</div>";
        } else {
            //$consecutivoPallet = consecutivo_pallet con el que se va a relacionar productos a pallet mixto
            if ($controller == 'Manifest') {
                $repo = new ManifestDetailsTempRepository();
            } elseif ($controller == 'Receiving') {
                $repo = new ReceivingDetailsTempRepository();
            } elseif ($controller == 'SalesOrder') {
                $repo = new ShippingRequestDetailsTempRepository();
            } elseif ($controller == 'Shipping') {
                $repo = new ShippingDetallesTempRepository();
            } elseif ($controller == 'Manufacturing_output') {
                $repo = new ManufacturingOutputTempRepository();
            } elseif ($controller == 'Invoice') {
                $repo = new InvoiceDetailsTempRepository();
            }
            
            $consecutivoPallet = $repo->getNextConsecutivoPallet($tokenForm);
        
            $stringForm = "<div class='col-md-5 col-xs-12 p-r-0'>";
            $stringForm .= $form->getModalFormString($controller, $tokenForm);
            $stringForm .= "</div>";
            
            $stringForm .= "<div class='col-md-7' col-xs-12>";
            $stringForm .= "<table id='manifestDetailsMixto' class='table table-condensed table-hover table-striped font-size-11'>";
            $stringForm .= "<thead>";
            $stringForm .= "<tr>";
            $stringForm .= "<th>".$this->_getTranslation('Accion')."</th>";
            $stringForm .= "<th class='text-center'>".$this->_getTranslation('Producto')."</th>";
            $stringForm .= "<th class='text-center'>".$this->_getTranslation('Tamaño')."</th>";
            $stringForm .= "<th class='text-center'>".$this->_getTranslation('Marca')."</th>";
            $stringForm .= "<th class='text-center'>".$this->_getTranslation('Calidad')."</th>";
            $stringForm .= "<th class='text-right'>".$this->_getTranslation('Cajas')."</th>";
            if ($controller === 'Receiving') {
                $stringForm .= "<th class='text-right'>".$this->_getTranslation('CajasR')."</th>";
            }
            $stringForm .= "</tr>";
            $stringForm .= "</thead>";
            $stringForm .= "<tbody>";
            $stringForm .= "</tbody>";
            $stringForm .= "<tfoot>";
            $stringForm .= "<td colspan='5' class='text-right'>".$this->_getTranslation('Total')."</td>";
            $stringForm .= "<td class='cajasTotalMixto text-right'></td>";
            if ($controller === 'Receiving') {
                $stringForm .= "<td class='cajasRTotalMixto text-right'></td>";
            }
            $stringForm .= "</tfoot>";
            $stringForm .= "</table>";
            $stringForm .= "</div>";
        }
            
        
        return array(
            'response'=>true,
            'stringForm'=>$stringForm,
            'mixto'=>$consecutivoPallet
        );
    }
    
    public function getListProductPropierties($options)
    {
        $repo = new ProductRepository;
        $data = $repo->getListProductPropierties($options);
       
        $listVariety = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listVariety']) && count($data['listVariety']) > 0) {
            foreach ($data['listVariety'] as $idVariety => $varietyName) {
                $listVariety .= "<option value='$idVariety'>$varietyName</option>";
            }
        }
        
        $listMadurity = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listMadurity']) && count($data['listMadurity']) > 0) {
            foreach ($data['listMadurity'] as $idMadurity => $madurityName) {
                $listMadurity .= "<option value='$idMadurity'>$madurityName</option>";
            }
        }
        
        $listSize = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listSize']) && count($data['listSize']) > 0) {
            foreach ($data['listSize'] as $idSize => $sizeName) {
                $listSize .= "<option value='$idSize'>$sizeName</option>";
            }
        }
        
        $listPacking = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listPacking']) && count($data['listPacking']) > 0) {
            foreach ($data['listPacking'] as $idPacking => $packingName) {
                $listPacking .= "<option value='$idPacking'>$packingName</option>";
            }
        }
        
        $listBrand = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listBrand']) && count($data['listBrand']) > 0) {
            foreach ($data['listBrand'] as $idBrand => $brandName) {
                $listBrand .= "<option value='$idBrand'>$brandName</option>";
            }
        }
        
        $listQuality = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listQuality']) && count($data['listQuality']) > 0) {
            foreach ($data['listQuality'] as $idQuality => $qualityName) {
                $listQuality .= "<option value='$idQuality'>$qualityName</option>";
            }
        }
        
        $listColor = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listColor']) && count($data['listColor']) > 0) {
            foreach ($data['listColor'] as $idColor => $colorName) {
                $listColor .= "<option value='$idColor'>$colorName</option>";
            }
        }
        
        $listLocation = "<option value='0' class='_listPropierties'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        if (is_array($data['listLocation']) && count($data['listLocation']) > 0) {
            foreach ($data['listLocation'] as $idLocation => $locationName) {
                $listLocation .= "<option value='$idLocation'>$locationName</option>";
            }
        }
        
        return array(
            'response'=>true,
            'listVariety'=>$listVariety,
            'listMadurity'=>$listMadurity,
            'listSize'=>$listSize,
            'listPacking'=>$listPacking,
            'listBrand'=>$listBrand,
            'listQuality'=>$listQuality,
            'listColor'=>$listColor,
            'listLocation'=>$listLocation
            );
    }
}
