<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class QualityAjax extends QualityRepository
{
    public $flashmessenger = null;
    
    public function __construct()
    {
        if (!$this->flashmessenger instanceof FlashMessenger) {
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }
    
    public function _getTranslation($text)
    {
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function getTranslation($options)
    {
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }
    
    public function getDataToEdit($options)
    {
        $qualityRepo = new QualityRepository();
        $data = $qualityRepo->getById($options['id']);
        $data['action'] = 'edit';
        
        return array(
            'response'=>true,
            'qualityData'=>$data
        );
    }
    
    public function deleteQuality($options)
    {
        $qualityRepo = new QualityRepository();
        
        if ($qualityRepo->delete($options['id'])) {
            $this->flashmessenger->addMessage(array('success'=>'Calidad se elimino exitosamente.'));
        }
        
        return array(
            'response'=>true
        );
    }
}
