<?php
class ReceivingAjax extends ReceivingRepository
{
    public function __construct()
    {
        parent::__construct();
    }

    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }

    public function setReceivingDetalles(array $options)
    {
        $data = array();
        foreach ($options['options'] as $row) {
            $data[$row['name']] = $row['value'];
        }
       
        $options = $data;
        $producto = $this->getProductoById($options['id_product']);
        if ($producto) {
            $data = array(
                'token_form'=>$options['token_form'],
                'idDetalleTemp'=>$options['idDetalleTemp'],
                'id_manifest'=>$options['id_manifest'],
                'id_product'=>$producto['id'],
                'descripcion'=>$producto['descripcion'],
                'id_variety'=>$options['id_variety'],
                'id_madurity'=>$options['id_madurity'],
                'id_size'=>$options['id_size'],
                'id_packing'=>$options['id_packing'],
                'id_brand'=>$options['id_brand'],
                'id_quality'=>$options['id_quality'],
                'id_color'=>$options['id_color'],
                'weight'=>$options['weight'],
                'quantity_boxes'=>$options['quantity_boxes'],
                //'cost'=>$options['cost'],
                'quantity_boxes_per_pallets'=>$options['quantity_boxes_per_pallets'],
                'quantity_pallets'=>$options['quantity_pallets'],
                'mixto'=>$options['mixto']);
            
            $this->insertDetalle($data);
            $receivingDetalles = $this->getReceivingDetalles($data['token_form']);
            $detalles = $this->listReceivingDetalles($receivingDetalles);
            $receivingDetallesMixto = null;
            $detallesMixto = null;
            
            if ($options['mixto'] !== '0' || $options['mixto'] !== null) {
                $receivingDetallesMixto = $this->getReceivingDetallesByMixto($options['mixto'], $data['token_form']);
                $detallesMixto = $this->listReceivingDetallesMixto($receivingDetallesMixto);
            }

            $json = array(
                'response' => true,
                'receivingDetalles' => $detalles['listDetalles'],
                'receivingSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                //'costoTotal'=>$detalles['costoTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasRTotal'=>$detalles['cajasRTotal'],
                'palletsRTotal'=>$detalles['palletsRTotal'],
                'receivingDetallesMixto' => $detallesMixto['listDetalles'],
                'cajasTotalMixto' => $detallesMixto['cajasTotal'],
                'costoTotalMixto' => $detallesMixto['costoTotal'],
                'cajasRTotalMixto' => $detallesMixto['cajasRTotal']
            );

            return $json;
        } else {
            $this->flashmessenger->addMessage(array('info'=>$this->_getTranslation('Producto no registrado.')));
            return $json = array(
                'response'=>null,
                'message'=>$this->flashmessenger->getMessageString());
        }
    }
    
    public function listReceivingDetalles($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $palletsTotal = 0;
        $sumaPesoTotal = 0;
        $cajasRTotal = 0;
        $palletsRTotal = 0;
        $tokenForm = null;
        
        foreach ($detalles as $detalle) {
            $tokenForm = $detalle['token_form'];
            $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
            $array = json_encode($detalle);
            
            $cajasTotal += $detalle['quantity_boxes_manifest'];
            $palletsTotal += $detalle['quantity_pallets_manifest'];
            $sumaPesoTotal += $detalle['weight_total'];
            
            $cajasRTotal += $detalle['quantity_boxes'];
            $palletsRTotal += $detalle['quantity_pallets'];
            
            $checked = '';
            $disabled = '';
            $disabledEdit = '';
            $disabledDelete = '';
            if ($detalle['status'] == '2') {
                $checked = 'checked';
            }
            if ($detalle['status'] == '1') {
                $disabledEdit = 'disabled';
            } #Si status = 1 (No recibido) btn Edit es diabled
            if (substr_count($detalle['added'], '1')) {
                $disabled = 'disabled';
            } #Si se agrego desde receiving btn Recibir es disabled
            if (substr_count($detalle['added'], '0')) {
                $disabledDelete = 'disabled';
            } #Si pallet se agrego desde Manifest btn Delete es diabled
           
            
            $descripcion = str_replace(',', "<br>", $detalle['descripcion']);
            $variety = str_replace(',', "<br>", $detalle['varietyName']);
            $size = str_replace(',', "<br>", $detalle['sizeName']);
            $packing = str_replace(',', "<br>", $detalle['packingName']);
            $quality = str_replace(',', "<br>", $detalle['qualityName']);
            $color = str_replace(',', "<br>", $detalle['colorName']);
            $weight = str_replace(',', "<br>", $detalle['weight_concat']);
            $boxesQuantity = str_replace(',', "<br>", $detalle['quantity_boxes_concat']);
            $palletsQuantity = str_replace(',', "<br>", $detalle['quantity_pallets_concat']);
            $boxesQuantityM = str_replace(',', "<br>", $detalle['quantity_boxes_manifest_concat']);
            $palletsQuantityM = str_replace(',', "<br>", $detalle['quantity_pallets_manifest_concat']);
            $cost = str_replace(',', "<br>", $detalle['cost_concat']);
            
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                ."<td class='text-center'>".$detalle['id_pallet']."</td>"
                ."<td class='text-center'><input name='vendor_tag_number|{$detalle['id_pallet']}' type='text' value='{$detalle['vendor_tag_number']}' class='_vendorTagNumber' style='width:100px' /></td>"
                ."<td class='text-center'><input name='pallet_temperature|{$detalle['id_pallet']}' type='text' value='{$detalle['pallet_temperature']}' class='_vendorTagNumber' style='width:50px' /></td>"
                ."<td class='text-center'>".$descripcion."</td>"
                ."<td class='text-center'>".$variety."</td>"
                ."<td class='text-center'>".$size."</td>"
                ."<td class='text-center'>".$packing."</td>"
                ."<td class='text-center'>".$quality."</td>"
                ."<td class='text-center'>".$color."</td>"
                ."<td class='text-right'>".$weight."</td>"
                ."<td class='text-right'>".$boxesQuantityM."</td>"
                ."<td class='text-right'>".$palletsQuantityM."</td>"
                ."<td class='text-right'>".$boxesQuantity."</td>"
                ."<td class='text-right'>".$palletsQuantity."</td>"
               ."<td class='text-center'> 
                    <label class='switch'>
                        <input type='checkbox' value='{$detalle['status']}' data-iddetalle='{$id}' $checked $disabled>
                        <span class='slider round'></span>
                    </label>
                </td>
                <td class='text-right'>                       
                    <a class='btn btn-xs btn-default $disabledEdit' onclick='setDetalleReceivingToEdit($array,this);' data-mixto='{$detalle['mixto']}' data-controller='Receiving'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-xs btn-danger $disabledDelete' onclick='deleteReceivingDetalles($id);'><i class='fa fa-trash'></i></a>
               </td>
               </tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'listSummary'=>$this->listReceivingSummary($tokenForm),
                     'cajasTotal'=>$cajasTotal,
                     'palletsTotal'=>$palletsTotal,
                     'pesoTotal'=>$sumaPesoTotal,
                     'cajasRTotal'=>$cajasRTotal,
                     'palletsRTotal'=>$palletsRTotal);
    }
    
    public function listReceivingSummary($tokenForm)
    {
        $summary = $this->getReceivingSummary($tokenForm);
        $listSummary = null;
        foreach ($summary as $detalle) {
            $listSummary .= "<tr>"
                ."<td class='text-center'>".$detalle['descripcion']."</td>"
                ."<td class='text-center'>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['packingName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-center'>".$detalle['colorName']."</td>"
                ."<td class='text-right'>".$detalle['weight']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes_manifest']."</td>"
                ."<td class='text-right'>".$detalle['quantity_pallets_manifest']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."<td class='text-right'>".$detalle['quantity_pallets']."</td>"
                ."</tr>";
        }
        
        return $listSummary;
    }
    
    public function getListReceivingDetalles($tokenForm)
    {
        $receivingDetalles = $this->getReceivingDetalles($tokenForm);
        $detalles = $this->listReceivingDetalles($receivingDetalles);

        $json = array(
                'response' => true,
                'receivingDetalles' => $detalles['listDetalles'],
                'receivingSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasRTotal'=>$detalles['cajasRTotal'],
                'palletsRTotal'=>$detalles['palletsRTotal'],
            );
        return $json;
    }

    public function deleteDetalles(array $options)
    {
        $id = $options['id'];
        $repository = new ReceivingDetailsTempRepository();
        $data = $repository->getById($id);
        
        if ($data['mixto']!=='0') {
            $result = $repository->deleteDetalleByMixto($data['mixto'], $data['token_form']);
        } else {
            $result = $repository->delete($id);
        }
        
        if ($result) {
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $receivingDetalles = $this->getReceivingDetalles($data['token_form']);
        $detalles = $this->listReceivingDetalles($receivingDetalles);
        
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'receivingDetalles'=>$detalles['listDetalles'],
                'receivingSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'costoTotal'=>$detalles['costoTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'cajasRTotal'=>$detalles['cajasRTotal'],
                'palletsRTotal'=>$detalles['palletsRTotal']
            );
        return $json;
    }
    
    public function listReceivingDetallesMixto($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $cajasRTotal = 0;
        $sumaCostoTotal = 0;
        foreach ($detalles as $detalle) {
            $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
            $array = json_encode($detalle);
            $cajasTotal += $detalle['quantity_boxes_manifest'];
            $sumaCostoTotal += $detalle['cost'];
            $cajasRTotal += $detalle['quantity_boxes'];
            
            $disabledDelete = '';
            if ($detalle['added'] == '0') {
                $disabledDelete = 'disabled';
            }
            
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                . "<td class='text-left'>                       
                    <a class='btn btn-xs btn-default' onclick='setDetalleReceivingToEditMixto($array);'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-xs btn-danger $disabledDelete' onclick='deleteReceivingDetallesMixto($id);'><i class='fa fa-trash'></i></a>
                </td>  "
                ."<td class='text-center'>".$detalle['descripcion']."<br/>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['brandName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes_manifest']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."</tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'cajasTotal'=>$cajasTotal,
                     'costoTotal'=>$sumaCostoTotal,
                     'cajasRTotal'=>$cajasRTotal);
    }
    
    public function getListReceivingDetallesMixto($options)
    {
        $receivingDetallesMixto = $this->getReceivingDetallesByMixto($options['mixto'], $options['token_form']);
        $detallesMixto = $this->listReceivingDetallesMixto($receivingDetallesMixto);
        
        $json = array(
            'response' => true,
            'receivingDetallesMixto' => $detallesMixto['listDetalles'],
            'cajasTotalMixto' => $detallesMixto['cajasTotal'],
            'cajasRTotalMixto' => $detallesMixto['cajasRTotal'],
            'costoTotalMixto' => $detallesMixto['costoTotal']
        );
        
        return $json;
    }
    
    public function deleteDetallesMixto(array $options)
    {
        $id = $options['id'];
        $repository = new ReceivingDetailsTempRepository();
        $currentData = $repository->getById($id);
        
        if ($repository->delete($id)) {
            $repository->assignMainProductForMixto($currentData['mixto'], $currentData['token_form']);
            $response = true;
            $msj = 'Producto eliminado correctamente.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $manifestDetalles = $this->getReceivingDetalles($currentData['token_form']);
        $detalles = $this->listReceivingDetalles($manifestDetalles);
        
        $dataMixto = $this->getListReceivingDetallesMixto(array('mixto'=>$currentData['mixto'],'token_form'=>$currentData['token_form']));
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'receivingDetalles'=>$detalles['listDetalles'],
                'receivingSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'costoTotal'=>$detalles['costoTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'cajasRTotal'=>$detalles['cajasRTotal'],
                'palletsRTotal'=>$detalles['palletsRTotal'],
                'receivingDetallesMixto' => $dataMixto['receivingDetallesMixto'],
                'cajasTotalMixto' => $dataMixto['cajasTotalMixto'],
                'cajasRTotalMixto' => $dataMixto['cajasRTotalMixto'],
                'costoTotalMixto' => $dataMixto['costoTotalMixto'],
            );
        return $json;
    }
    
    public function receiveUnreceivePallet($options)
    {
        $idDetail = $options['idDetail'];
        $repoReceivingDetailTem = new ReceivingDetailsTempRepository();
        
        if (!$repoReceivingDetailTem->receiveUnreceivePallet($idDetail)) {
            return array(
                'response'=>false,
                'msg'=>$this->flashmessenger->getRawMessage()
            );
        }
        
        return $this->getListReceivingDetalles($options['token_form']);
    }
    
    public function allowEditReceiving($options)
    {
        $entityRepository = new EntityRepository();
        $entityRepository->update($options['idReceiving'], array('allow_edit'=>'1'), 'receiving');
        return array(
            'response'=>true,
        );
    }
    
    public function updateVendorTagNumberOrigin($options)
    {
        if (!isset($options['vendor_tag_number'])) {
            return array('response'=>true);
        }
        $tokenForm = $options['token_form'];
        $data = array();
        foreach ($options['vendor_tag_number'] as $row) {
            $data[$row['name']] = $row['value'];
        }
        
        $repository = new ReceivingDetailsTempRepository();
        foreach ($data as $palletId => $tagNumber) {
            parent::query("UPDATE ".$repository->getTableName()." SET vendor_tag_number = '$tagNumber' WHERE id_pallet = '$palletId' AND token_form = '$tokenForm'");
        }
        
        return array(
            'response'=>true
        );
    }
    
    public function updateVendorTagNumber($options)
    {
        if (!isset($options['vendor_tag_number'])) {
            return array('response'=>true);
        }
        $tokenForm = $options['token_form'];
        $data = array();
        foreach ($options['vendor_tag_number'] as $row) {
            $data[$row['name']] = $row['value'];
        }
       
        $dataUpdate = array();
        foreach ($data as $key => $value) {
            $key = explode('|', $key);
            $dataUpdate[$key[1]][$key[0]] = $value;
        }

        $repository = new ReceivingDetailsTempRepository();
        foreach ($dataUpdate as $palletId => $values) {
            $stringSet = null;
            foreach ($values as $field => $value) {
                if ($value == '_NULL' || is_null($value) || trim($value)=='') {
                    $stringSet .= "$field = NULL,";
                } else {
                    $stringSet .= "$field = '$value',";
                }
            }
            
            $stringSet = trim($stringSet, ',');
            parent::query("UPDATE ".$repository->getTableName()." SET $stringSet WHERE id_pallet = '$palletId' AND token_form = '$tokenForm'");
        }
        
        return array(
            'response'=>true
        );
    }
}
