<?php
class ShippingRequestAjax extends ShippingRequestRepository
{
    public $status_shipping_request = null;
    public function __construct()
    {
        parent::__construct();
    }

    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }

    public function setShippingRequestDetalles(array $options)
    {
        $msg = null;
        if (isset($options['options'])) {
            $data = array();
            foreach ($options['options'] as $row) {
                $data[$row['name']] = $row['value'];
            }
            
            $options = $data;
            $this->status_shipping_request = $options['status'];
            $producto = $this->getProductoById($options['id_product']);
            $data = array(
                'token_form'=>$options['token_form'],
                'idDetalleTemp'=>$options['idDetalleTemp'],
                'id_shipping_request'=>$options['id_shipping_request'],
                'id_product'=>$producto['id'],
                'descripcion'=>$producto['descripcion'],
                'id_variety'=>$options['id_variety'],
                'id_madurity'=>$options['id_madurity'],
                'id_size'=>$options['id_size'],
                'id_packing'=>$options['id_packing'],
                'id_brand'=>$options['id_brand'],
                'id_quality'=>$options['id_quality'],
                'id_color'=>$options['id_color'],
                'weight'=>$options['weight'],
                'quantity_boxes'=>$options['quantity_boxes'],
                'price'=>$options['price'],
                'quantity_boxes_per_pallets'=>$options['quantity_boxes_per_pallets'],
                'quantity_pallets'=>$options['quantity_pallets'],
                'mixto'=>$options['mixto'],
                'lot'=>$options['lot'],
                'status'=>$data['status']);
            
            if (!$this->insertDetalle($data)) {
                return array(
                    'response'=>false,
                    'msg'=>$this->flashmessenger->getRawMessage()
                );
            }
        } /*elseif(isset($options['id_pallet'])){
            $repoInventoty = new InventoryRepository();
            $data = $repoInventoty->getInventoryByPallet($options['id_pallet']);

            if($data){
                foreach($data as $row){
                    if($row['id_customer'] != $options['customer']){
                        $this->flashmessenger->addMessage(array('danger'=>'Producto no corresponde a cliente seleccionado.'));
                        return array(
                            'response'=>false,
                            'msg'=>$this->flashmessenger->getRawMessage()
                        );
                    }
                }


                $repoShippingDetalles = new ShippingRequestDetailsTempRepository();
                $mixto = $options['mixto'];
                if(is_array($data) && count($data) > 1 && $mixto === '0'){
                    #si pallet scaneado es mixto, aunque lo scanee en text para 'normales' lo debo insertar como mixo
                    #Por eso obtengo el nextConsecutivePallet
                    $mixto = $repoShippingDetalles->getNextConsecutivoPallet($options['token_form']);
                }
                foreach($data as $product){
                    $product['id_pallet_inventory'] = $product['id_pallet'];
                    $product['id_inventory'] = $product['id'];
                    $product['token_form'] = $options['token_form'];

                    $quantity_boxes = $repoShippingDetalles->getAvailableStockByIdPallet($product);
                    #Solo si el stock disponible es mayor a 0, lo tratamos insertar#
                    if($quantity_boxes['available'] > 0){
                        $product['quantity_boxes'] = $quantity_boxes['available'];
                        $product['quantity_boxes_per_pallets'] = $quantity_boxes['available'];
                        $product['mixto'] = $mixto;
                        $product['token_form'] = $options['token_form'];

                        unset($product['product_description']);
                        if(!$this->insertDetalle($product)){
                             return array(
                                'response'=>false,
                                'msg'=>$this->flashmessenger->getRawMessage()
                            );
                        }
                    }else{
                        $msg = true;
                        $this->flashmessenger->addMessage(array('danger'=>"No se agrego: {$product['product_description']}, no hay stock disponible en este pallet."));
                    }
                }
            }else{
                $this->flashmessenger->addMessage(array('danger'=>'Pallet no tiene stock disponible.'));
                return array(
                    'response'=>false,
                    'msg'=>$this->flashmessenger->getRawMessage()
                );
            }
        }           */
            
        $shippingRequestDetalles = $this->getShippingRequestDetalles($options['token_form']);
        $detalles = $this->listShippingRequestDetalles($shippingRequestDetalles);
        $shippingRequestDetallesMixto = null;
        $detallesMixto = null;

        if ($options['mixto'] !== '0' || $options['mixto'] !== null) {
            $shippingRequestDetallesMixto = $this->getShippingRequestDetallesByMixto($options['mixto'], $options['token_form']);
            $detallesMixto = $this->listShippingRequestDetallesMixto($shippingRequestDetallesMixto);
        }

        $json = array(
            'response' => true,
            'shippingRequestDetalles' => $detalles['listDetalles'],
            'shippingRequestSummary'=>$detalles['listSummary'],
            'cajasTotal'=>$detalles['cajasTotal'],
            'precioTotal'=>$detalles['precioTotal'],
            'palletsTotal'=>$detalles['palletsTotal'],
            'pesoTotal'=>$detalles['pesoTotal'],
            'shippingRequestDetallesMixto' => $detallesMixto['listDetalles'],
            'cajasTotalMixto' => $detallesMixto['cajasTotal'],
            'precioTotalMixto' => $detallesMixto['precioTotal'],
            'pesoTotalMixto' => $detallesMixto['pesoTotal'],
        );
        
        if ($msg) {
            $json['msg'] = $this->flashmessenger->getMessageString();
        }

        return $json;
    }
    
    public function listShippingRequestDetalles($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $palletsTotal = 0;
        $pesoTotal = 0;
        $sumaPesoTotal = 0;
        $sumaPrecioTotal = 0;
        $tokenForm = null;
        
        if ($detalles) {
            $element = key($detalles);
            $shippingRequestData = $this->getById($detalles[$element]['id_shipping_request']);
            
            foreach ($detalles as $detalle) {
                $tokenForm = $detalle['token_form'];
                $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
                $array = json_encode($detalle);
                $cajasTotal += $detalle['quantity_boxes'];
                $palletsTotal += $detalle['quantity_pallets'];
                $sumaPesoTotal += $detalle['weight_total'];
                $sumaPrecioTotal += $detalle['price_total'];

                $descripcion = str_replace(',', "<br>", $detalle['descripcion']);
                $variety = str_replace(',', "<br>", $detalle['varietyName']);
                $size = str_replace(',', "<br>", $detalle['sizeName']);
                $packing = str_replace(',', "<br>", $detalle['packingName']);
                $quality = str_replace(',', "<br>", $detalle['qualityName']);
                $color = str_replace(',', "<br>", $detalle['colorName']);
                $weight = str_replace(',', "<br>", $detalle['weight_concat']);
                $boxesQuantity = str_replace(',', "<br>", $detalle['quantity_boxes_concat']);
                $price = str_replace(',', "<br>", $detalle['price_concat']);
                $palletsQuantity = str_replace(',', "<br>", $detalle['quantity_pallets_concat']);
                $lot = str_replace(',', "<br>", $detalle['lot_concat']);

                $id = $detalle['id'];
                $listDetalles .= "<tr>";
                $listDetalles .= "<td class='text-center' style='white-space:nowrap'>";

                if (1==1) {
                    $listDetalles .= "<a class='btn btn-sm btn-default' onclick='setDetalleShippingRequestToEdit($array,this);' data-mixto='{$detalle['mixto']}' data-controller='SalesOrder'><i class='fa fa-pencil'></i></a>";
                }


                if ($this->status_shipping_request == '1' || $this->status_shipping_request == null) {
                    $listDetalles .= "<a class='btn btn-sm btn-danger' onclick='deleteShippingRequestDetalles($id,this);' data-mixto='{$detalle['mixto']}'><i class='fa fa-trash'></i></a>";
                }

                $listDetalles .="<td class='text-center'>".$detalle['id_pallet']."</td>"
                    ."<td class='text-center'>".$lot."</td>"
                    ."<td class='text-center'>".$descripcion."</td>"
                    ."<td class='text-center'>".$variety."</td>"
                    ."<td class='text-center'>".$size."</td>"
                    ."<td class='text-center'>".$packing."</td>"
                    ."<td class='text-center'>".$quality."</td>"
                    ."<td class='text-center'>".$color."</td>"
                    ."<td class='text-right'>".$weight."</td>"
                    ."<td class='text-right'>".$boxesQuantity."</td>"
                    ."<td class='text-right'>".$price."</td>"
                    ."<td class='text-right'>".number_format($detalle['price_total'], 2)."</td>"
                    ."</tr>";
            }
        }
        
        return array('listDetalles'=>$listDetalles,
                     'listSummary'=>$this->listShippingRequestSummary($tokenForm),
                     'cajasTotal'=>$cajasTotal,
                     'palletsTotal'=>$palletsTotal,
                     'pesoTotal'=>$sumaPesoTotal,
                     'precioTotal'=>$sumaPrecioTotal);
    }
    
    public function listShippingRequestSummary($tokenForm)
    {
        $summary = $this->getShippingRequestSummary($tokenForm);
        $listSummary = null;
        
        if ($summary) {
            $element = key($summary);
            $shippingRequestData = $this->getById($summary[$element]['id_shipping_request']);
            
            foreach ($summary as $detalle) {
                $array = json_encode($detalle);
                $total = $detalle['quantity_boxes'] * $detalle['price'];
                $id = $detalle['id'];
                $listSummary .= "<tr>";
                /*
                $listSummary .= "<td class='text-center' style='white-space:nowrap'>";

                if($this->status_shipping_request == '1' ){
                    $listSummary .= "<a class='btn btn-sm btn-default' onclick='setDetalleShippingRequestToEdit($array,this);' data-mixto='{$detalle['mixto']}' data-controller='SalesOrder' data-keyproductprice='{$detalle['product_key_price']}'><i class='fa fa-pencil'></i></a>";
                }

                if($this->status_shipping_request == '1' || $this->status_shipping_request == null){
                    $listSummary .= " <a class='btn btn-sm btn-danger' onclick='deleteShippingRequestDetalles($id,this);' data-mixto='{$detalle['mixto']} data-keyproductprice='{$detalle['product_key_price']}'><i class='fa fa-trash'></i></a>";
                }         */
                
                $listSummary .="</td>"
                    //."<td class='text-center'>".$detalle['lot']."</td>"
                    ."<td class='text-center'>".$detalle['descripcion']."</td>"
                    ."<td class='text-center'>".$detalle['varietyName']."</td>"
                    ."<td class='text-center'>".$detalle['sizeName']."</td>"
                    ."<td class='text-center'>".$detalle['packingName']."</td>"
                    ."<td class='text-center'>".$detalle['qualityName']."</td>"
                    ."<td class='text-center'>".$detalle['colorName']."</td>"
                    ."<td class='text-right'>".$detalle['weight']."</td>"
                    ."<td class='text-right'>".$detalle['quantity_boxes']."</td>";
                if ($this->status_shipping_request == '1' || $this->status_shipping_request == null || $shippingRequestData['invoiced'] == '0') {
                    $listSummary .= " <td class='col-md-1 text-right'><input type='text' name='{$detalle['product_key_price']}' data-keyproductprice='{$detalle['product_key_price']}' value='{$detalle['price']}' class='form-control _priceByProductKeyPrice _maskDouble' style='width:100%;text-align:right' /></td>";
                } else {
                    $listSummary .="<td class='col-md-1 text-right'>{$detalle['price']}</td>";
                }

                $listSummary .= "<td class='text-right'>".number_format($total, 2)."</td>";
                $listSummary .= "</tr>";
            }
        }
        
        return $listSummary;
    }
    
    public function getListShippingRequestDetalles($tokenForm, $status = null)
    {
        if ($status) {
            $this->status_shipping_request = $status;
        }
        $shippingRequestDetalles = $this->getShippingRequestDetalles($tokenForm);
        $detalles = $this->listShippingRequestDetalles($shippingRequestDetalles);

        $json = array(
                'response' => true,
                'shippingRequestDetalles' => $detalles['listDetalles'],
                'shippingRequestSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'precioTotal'=>$detalles['precioTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal']
            );
        return $json;
    }

    public function deleteDetalles(array $options)
    {
        $id = $options['id'];
        $repository = new ShippingRequestDetailsTempRepository();
        $data = $repository->getById($id);
        $tokenForm = $data['token_form'];
        
        if ($data['mixto']!=='0') {
            $result = $repository->deleteDetalleByMixto($data['mixto'], $tokenForm);
        } else {
            $result = $repository->delete($id);
        }
        
        if ($result) {
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $shippingRequestDetalles = $this->getShippingRequestDetalles($tokenForm);
        $detalles = $this->listShippingRequestDetalles($shippingRequestDetalles);
        
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'shippingRequestDetalles'=>$detalles['listDetalles'],
                'shippingRequestSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'precioTotal'=>$detalles['precioTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
            );
        return $json;
    }
    
    public function listShippingRequestDetallesMixto($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $pesoTotal = 0;
        $sumaPesoTotal = 0;
        $sumaPrecioTotal = 0;
        
        foreach ($detalles as $detalle) {
            $detalle['quantity_boxes_per_pallets'] = $detalle['quantity_boxes'];
            $array = json_encode($detalle);
            $cajasTotal += $detalle['quantity_boxes'];
            $sumaPesoTotal += $detalle['weight'];
            $sumaPrecioTotal += $detalle['price'];
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                . "<td class='text-left'>                       
                    <a class='btn btn-xs btn-default' onclick='setDetalleShippingRequestToEditMixto($array);'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-xs btn-danger' onclick='deleteShippingRequestDetallesMixto($id);'><i class='fa fa-trash'></i></a>
                </td>  "
               ."<td class='text-center'>".$detalle['descripcion']."<br/>".$detalle['varietyName']."</td>"
               ."<td class='text-center'>".$detalle['sizeName']."</td>"
               ."<td class='text-center'>".$detalle['brandName']."</td>"
               ."<td class='text-center'>".$detalle['qualityName']."</td>"
               ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
               ."</tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'cajasTotal'=>$cajasTotal,
                     'pesoTotal'=>$sumaPesoTotal,
                     'precioTotal'=>$sumaPrecioTotal);
    }
    
    public function getListShippingRequestDetallesMixto($options)
    {
        $shippingRequestDetallesMixto = $this->getShippingRequestDetallesByMixto($options['mixto'], $options['token_form']);
        $detallesMixto = $this->listShippingRequestDetallesMixto($shippingRequestDetallesMixto);
        
        $json = array(
            'response' => true,
            'shippingRequestDetallesMixto' => $detallesMixto['listDetalles'],
            'cajasTotalMixto' => $detallesMixto['cajasTotal'],
            'pesoTotalMixto' => $detallesMixto['pesoTotal'],
            'precioTotalMixto' => $detallesMixto['precioTotal'],
        );
        
        return $json;
    }
    
    public function deleteDetallesMixto(array $options)
    {
        $id = $options['id'];
        $repository = new ShippingRequestDetailsTempRepository();
        $currentData = $repository->getById($id);
        
        if ($repository->delete($id)) {
            $repository->assignMainProductForMixto($currentData['mixto'], $currentData['token_form']);
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $shippingRequestDetalles = $this->getShippingRequestDetalles($currentData['token_form']);
        $detalles = $this->listShippingRequestDetalles($shippingRequestDetalles);
        
        $dataMixto = $this->getListShippingRequestDetallesMixto(array('mixto'=>$currentData['mixto'],'token_form'=>$currentData['token_form']));
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'shippingRequestDetalles'=>$detalles['listDetalles'],
                'shippingRequestSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'precioTotal'=>$detalles['precioTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'shippingRequestDetallesMixto' => $dataMixto['shippingRequestDetallesMixto'],
                'cajasTotalMixto' => $dataMixto['cajasTotalMixto'],
                'pesoTotalMixto' => $dataMixto['pesoTotalMixto'],
                'precioTotalMixto' => $dataMixto['precioTotalMixto'],
            );
        return $json;
    }
    
    public function getAvailableInventory($options)
    {
        $idProduct = $options['id_product'];
        
        $repoProduct = new ProductRepository();
        $dataProduct = $repoProduct->getById($idProduct);
        //$message = "<h4>".$this->_getTranslation('Stock disponible para')." ".$dataProduct['descripcion']."</h4>";
        $message = '';
        
        $repoInventory = new InventoryRepository();
        $availableInventory = $repoInventory->getSummaryInventory($idProduct);
        
        if ($availableInventory === null) {
            $message .= "<p>".$this->_getTranslation('No hay existencias para este producto.')."</p>";
            $json = array(
                 'response'=>false,
                 'availableInventory'=>null,
                 'message'=>$message);
            
            return $json;
        }
        
        $string = '';
        foreach ($availableInventory as $producto) {
            $infoProducto = json_encode($producto);
            
            #setReceivingDetail funcion generica para popular formularios con info enviada. nombrecampo=>valor
            $string .= "<tr style='cursor:pointer' onclick='setInfoProductShippingRequest($infoProducto)'>";
     
            $string .=  "<td style='text-align:center'>{$producto['date']}</td>
                            <td style='text-align:center'>{$producto['lot']}</td>
                            <td style='text-align:center'>{$producto['descripcion']}</td>
                            <td style='text-align:center'>{$producto['varietyName']}</td>
                            <td style='text-align:center'>{$producto['madurityName']}</td>
                            <td style='text-align:center'>{$producto['sizeName']}</td>
                            <td style='text-align:center'>{$producto['packingName']}</td>
                            <td style='text-align:center'>{$producto['brandName']}</td>
                            <td style='text-align:center'>{$producto['qualityName']}</td>                                
                            <td style='text-align:center'>{$producto['colorName']}</td>
                            <td style='text-align:center'>{$producto['weight']}</td>
                            <td style='text-align:center'>{$producto['quantity_boxes']}</td>
                            <td style='text-align:center' class='success'>{$producto['available']}</td>
                            <td style='text-align:center'>{$producto['locationName']}</td>
                       </tr>";
        }
        
        $json = array(
                 'response'=>true,
                 'availableInventory'=>$string,
                 'message'=>$message);
        return $json;
    }
    
    public function updateSalesOrderPricetByProductKeyPrice($options)
    {
        $manifestDetailsTempRepo = new ShippingRequestDetailsTempRepository();
        $manifestDetailsTempRepo->updatePriceByProductKeyPrice($options);
        
        return $this->getListShippingRequestDetalles($options['tokenForm'], $options['status']);
    }
    
    public function getCustomerMethodPayment($options)
    {
        $customer = $options['customer'];
        $date = $options['date'];
        $dueDate = $date;
        
        $repoCustomer = new CustomerRepository();
        $dataCustomer = $repoCustomer->getById($customer);
        
        $paymentTermsRepo = new PaymentTermsRepository();
        $paymentTermsData = $paymentTermsRepo->getById($dataCustomer['payment_terms']);
        
        if ($date !== '' && !is_null($date)) {
            $tools = new Tools();
            $date = $tools->setFormatDateToDB($date);
            
            $dueDate = $this->getDueDate($date, $paymentTermsData['days']);
            $dueDate = $tools->setFormatDateToForm($dueDate);
        }
        
        return array(
            'response'=>true,
            'payment_terms'=>$paymentTermsData['id'],
            'due_date'=>$dueDate
        );
    }
    
    public function getCustomerDefaultSettings($options)
    {
        $customerRepo = new CustomerAddressRepository();
        $mainAddress = $customerRepo->getCustomerShippingAddressDefaultByIdCustomer($options['customer']);
        $shippingAddress = $customerRepo->getListSelectShippingAddress($options['customer']);

        $string = '';
        if ($shippingAddress) {
            foreach ($shippingAddress as $key => $value) {
                $selected = null;
                if ($key == $mainAddress['id']) {
                    $selected = 'selected';
                }
                $string .="<option value='{$key}' $selected>{$value}</option>";
            }
        }
        
        return array(
            'response'=>true,
            'shippingAddress'=>$string
        );
    }
    
    public function getSalesOrderVsShipping($options)
    {
        $string = '';
        $salesOrderVsShipping = $this->_getSalesOrderVsShipping($options['id'], $options['filterLot']);
       
        if ($salesOrderVsShipping) {
            foreach ($salesOrderVsShipping as $row) {
                $trClass = '';
                if ($row['required_boxes'] == $row['shipped_boxes']) {
                    $trClass = 'success';
                }
                if ($row['required_boxes'] > $row['shipped_boxes']) {
                    $trClass = 'warning';
                }
                if ($row['required_boxes'] != $row['shipped_boxes'] && ($row['required_boxes'] > 0 && $row['shipped_boxes'] > 0)) {
                    $trClass = 'warning';
                }
                if ($row['shipped_boxes'] == 0) {
                    $trClass = 'danger';
                }
                if ($row['required_boxes'] == 0) {
                    $trClass = 'danger';
                }
                
                $string .= "<tr class='{$trClass}'>";
                $string .= "<td class='text-center'>{$row['lot']}</td>";
                $string .= "<td class='text-center'>{$row['descripcion']}</td>";
                $string .= " <td class='text-center'>{$row['variety_name']}</td>";
                $string .= " <td class='text-center'>{$row['size_name']}</td>";
                $string .= "<td class='text-center'>{$row['packing_name']}</td>";
                $string .= "<td class='text-center'>{$row['quality_name']}</td>";
                $string .= "<td class='text-center'>{$row['color_name']}</td>";
                $string .= "<td class='text-center'>{$row['weight']}</td>";
                $string .= "<td class='text-center'>{$row['price']}</td>";
                $string .= "<td class='text-right'>{$row['required_boxes']}</td>";
                $string .= "<td class='text-right'>{$row['shipped_boxes']}</td>";
                $string .= "</tr>";
            }
        }
        
        return array(
            'response'=>true,
            'salesOrderVsShippingList'=>$string
        );
    }
    
    public function replaceSODWithSD($options)
    {
        $this->_replaceSODWithSD($options['shipping_request_id']);
        
        return array(
            'response'=>true,
        );
    }
    
    public function replaceSODWithOSO($options)
    {
        $this->_replaceSODWithOSO($options['shipping_request_id']);
        
        return array(
            'response'=>true,
        );
    }
    
    public function createInvoice($options)
    {
        $this->_createInvoice($options);
        
        return array(
            'response'=>true,
        );
    }
}
