<?php
class WasteAjax extends WasteRepository
{
    public function __construct()
    {
        parent::__construct();
    }

    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }

    public function setWasteDetalles(array $options)
    {
        if (isset($options['options'])) {
            $data = array();
            foreach ($options['options'] as $row) {
                $data[$row['name']] = $row['value'];
            }

            $options = $data;
            $producto = $this->getProductoById($options['id_product']);
            $data['descripcion'] = $producto['descripcion'];
            
            unset($data['action'],$data['agregar_producto_por_idpallet'],$data['mixto'],$data['quantity_pallets']);
            if (!$this->insertDetalle($data)) {
                return array(
                    'response'=>false,
                    'msg'=>$this->flashmessenger->getRawMessage()
                );
            }
        } elseif (isset($options['id_pallet'])) {
            $repoInventoty = new InventoryRepository();
            $data = $repoInventoty->getInventoryByPallet($options['id_pallet']);
            if ($data) {
                $repoShippingDetalles = new WasteDetallesTempRepository();
                foreach ($data as $product) {
                    $product['id_pallet_inventory'] = $product['id_pallet'];
                    $product['id_inventory'] = $product['id'];
                    $product['token_form'] = $options['token_form'];
                    /*
                    $quantity_boxes = $repoShippingDetalles->getAvailableStock($product);
                    $product['quantity_boxes'] = $quantity_boxes;          */
                   
                    if (!$this->insertDetalle($product)) {
                        return array(
                            'response'=>false,
                            'msg'=>$this->flashmessenger->getRawMessage()
                        );
                    }
                }
            }
        }
            
        $shippingDetalles = $this->getShippingDetalles($options['token_form']);
        $detalles = $this->listShippingDetalles($shippingDetalles);

        $json = array(
            'response' => true,
            'shippingDetalles' => $detalles['listDetalles'],
            'shippingSummary'=>$detalles['listSummary'],
            'cajasTotal'=>$detalles['cajasTotal'],
            'palletsTotal'=>$detalles['palletsTotal'],
            'pesoTotal'=>$detalles['pesoTotal']
        );

        return $json;
    }
    
    public function listShippingDetalles($detalles)
    {
        $listDetalles = "";
        $cajasTotal = 0;
        $palletsTotal = 0;
        $pesoTotal = 0;
        $sumaPesoTotal = 0;
        $tokenForm = null;
        
        foreach ($detalles as $detalle) {
            $tokenForm = $detalle['token_form'];
            $array = json_encode($detalle);
            $cajasTotal += $detalle['quantity_boxes'];
            $pesoTotal = $detalle['quantity_boxes']*$detalle['weight'];
            $sumaPesoTotal += $pesoTotal;
            
            $id = $detalle['id'];
            $listDetalles .= "<tr>"
                . "<td class='text-left'>                       
                    <a class='btn btn-xs btn-default' onclick='setDetalleWasteToEdit($array,this);' data-mixto='0' data-controller='Waste'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-xs btn-danger' onclick='deleteWasteDetalles($id,this);'><i class='fa fa-trash'></i></a>
                </td>  "
                ."<td class='text-center'>".$detalle['id_pallet_inventory']."</td>"
                ."<td class='text-center'>".$detalle['descripcion']."</td>"
                ."<td class='text-center'>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['packingName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-center'>".$detalle['colorName']."</td>"
                ."<td class='text-right'>".$detalle['weight']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."</tr>";
        }
        
        return array('listDetalles'=>$listDetalles,
                     'listSummary'=>$this->listShippingSummary($tokenForm),
                     'cajasTotal'=>$cajasTotal,
                     'palletsTotal'=>$palletsTotal,
                     'pesoTotal'=>$sumaPesoTotal);
    }
    
    public function listShippingSummary($tokenForm)
    {
        $summary = $this->getShippingSummary($tokenForm);
        $listSummary = null;
        foreach ($summary as $detalle) {
            $listSummary .= "<tr>"
                ."<td class='text-center'>".$detalle['descripcion']."</td>"
                ."<td class='text-center'>".$detalle['varietyName']."</td>"
                ."<td class='text-center'>".$detalle['sizeName']."</td>"
                ."<td class='text-center'>".$detalle['packingName']."</td>"
                ."<td class='text-center'>".$detalle['qualityName']."</td>"
                ."<td class='text-center'>".$detalle['colorName']."</td>"
                ."<td class='text-right'>".$detalle['weight']."</td>"
                ."<td class='text-right'>".$detalle['quantity_boxes']."</td>"
                ."</tr>";
        }
        
        return $listSummary;
    }
    
    public function getListWasteDetalles($tokenForm)
    {
        $shippingDetalles = $this->getShippingDetalles($tokenForm);
        $detalles = $this->listShippingDetalles($shippingDetalles);

        $json = array(
                'response' => true,
                'shippingDetalles' => $detalles['listDetalles'],
                'shippingSummary'=>$detalles['listSummary'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
                'pesoTotal'=>$detalles['pesoTotal']
            );
        return $json;
    }

    public function deleteDetalles(array $options)
    {
        $id = $options['id'];
        $repository = new WasteDetallesTempRepository();
        $currenData = $repository->getById($id);
        
        $result = $repository->delete($id);
        
        if ($result) {
            $response = true;
            $msj = 'Producto eliminado correctamentes.';
        } else {
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $shippingDetalles = $this->getShippingDetalles($currenData['token_form']);
        $detalles = $this->listShippingDetalles($shippingDetalles);
        
        $json = array(
                'response' => $response,
                'message'=>$this->_getTranslation($msj),
                'shippingDetalles'=>$detalles['listDetalles'],
                'shippingSummary'=>$detalles['listSummary'],
                'pesoTotal'=>$detalles['pesoTotal'],
                'cajasTotal'=>$detalles['cajasTotal'],
                'palletsTotal'=>$detalles['palletsTotal'],
            );
        return $json;
    }
    
    public function getAvailableInventoryByPallet($options)
    {
        $idProduct = $options['id_product'];
        
        $repoProduct = new ProductRepository();
        $dataProduct = $repoProduct->getById($idProduct);
        $message = "<h4>".$this->_getTranslation('Stock disponible para')." ".$dataProduct['descripcion']."</h4>";
        
        $repoInventory = new InventoryRepository();

        $availableInventory = $repoInventory->getSummaryInventoryByPallet($idProduct);
        
        if ($availableInventory === null) {
            $message .= "<p>".$this->_getTranslation('No hay existencias para este producto.')."</p>";
            $json = array(
                 'response'=>false,
                 'availableInventory'=>null,
                 'message'=>$message);
            
            return $json;
        }
        
        $string = "";
        foreach ($availableInventory as $producto) {
            $infoProducto = json_encode($producto);
            
            #setReceivingDetail funcion generica para popular formularios con info enviada. nombrecampo=>valor
            $string .= "<tr style='cursor:pointer' onclick='setInfoProductShipping($infoProducto)'>";
     
            $string .=  "<td style='text-align:center'>{$producto['id_pallet']}</td>"
                    . "     <td style='text-align:center'>{$producto['date']}</td>
                            <td style='text-align:center'>{$producto['lot']}</td>
                            <td style='text-align:center'>{$producto['descripcion']}</td>
                            <td style='text-align:center'>{$producto['varietyName']}</td>
                            <td style='text-align:center'>{$producto['madurityName']}</td>
                            <td style='text-align:center'>{$producto['sizeName']}</td>
                            <td style='text-align:center'>{$producto['packingName']}</td>
                            <td style='text-align:center'>{$producto['brandName']}</td>
                            <td style='text-align:center'>{$producto['qualityName']}</td>                                
                            <td style='text-align:center'>{$producto['colorName']}</td>
                            <td style='text-align:center'>{$producto['weight']}</td>
                            <td style='text-align:center'>{$producto['quantity_boxes']}</td>
                       </tr>";
        }
        
        $json = array(
                 'response'=>true,
                 'availableInventory'=>$string,
                 'message'=>$message);
        return $json;
    }
}
