<?php
class CuentaDeGastosPDF
{
    private $pathfFileCreated = null;
    public function __construct($idFactura, $createFile = null)
    {
        $factura = new FacturaRepository();
        $factura->setOptions($factura->getById($idFactura));
        $factura->setId($idFactura);
        
        $cliente = new ClienteRepository();
        $cliente->setOptions($cliente->getById($factura->getIdCliente()));
        
        $empresa = new EmpresaRepository();
        $empresa->setOptions($empresa->getById(1));
        
        $sucursal = new SucursalRepository();
        $sucursal->setOptions($sucursal->getById($factura->getSucursal()));
        
        //Modifique metodo AddPage para qe ricibiera un tercer parametro, dicho parametro contiene el texto para a marca de agua.
        // para crear la marca de agua agregue las funciones Header y RotatedText en pdf.php
        $pdf = new PDF();
        if ($factura->getStatus() =='3') {
            $pdf->AddPage('', '', 'Cancelada');
        } else {
            $pdf->AddPage('', '');
        }

        $pdf->SetFillColor(51, 153, 255);
        $pdf->SetY(7);
        $pic = 'data://text/plain;base64,' . base64_encode($sucursal->getLogo());
        // extract dimensions from image $info = getimagesize($pic);
        $image_type = explode("/", $sucursal->getImageType());
        $pdf->Image($pic, 20, 5, 35, 30, $image_type[1]);

        $pdf->SetFont('Arial', '', '12');
        $pdf->SetTextColor(0);
        $pdf->Cell(190, 10, $empresa->getNombre()."\n".$empresa->getPaginaWeb(), '0', 1, 'R');

        $pdf->SetFont('Arial', '', '7');
        $direccion = $empresa->getRFC();
        $direccion .= "\n".$empresa->getRegimenFiscal()." - ".$empresa->getRegimenFiscalNombre();
        $direccion .="\n".utf8_decode($empresa->getCalleNum());
        $direccion .= "\n".utf8_decode($empresa->getColonia()).' '.$empresa->getCodigoPostal();
        $direccion .= "\n".utf8_decode($empresa->getCiudad()).', '.utf8_decode($empresa->getEstado());
        $direccion .= "\n".$empresa->getTelefono();
        $pdf->Cell(190, 15, $direccion, '0', 1, 'R');

        $pdf->ln(5);
        $pdf->SetFont('Arial', '', '12');
        $pdf->SetTextColor(255);
        $pdf->SetDrawColor(51, 153, 255);
        //$pdf->SetDrawColor(0);
        $pdf->SetX(0);
        $pdf->Cell(60, 2, '', '1', 1, 'R', true);
        $pdf->SetX(0);
        $pdf->Cell(60, 5, "FACTURA ".$factura->getNumFactura(), '1', 1, 'R', true);
        $pdf->SetTextColor(255);
        $pdf->SetX(0);
        $pdf->SetFont('Arial', '', '7');
        $pdf->Cell(60, 3, 'Tipo de comprobante: '.$factura->getTipoComprobante()." - ".$factura->getTipoComprobanteNombre(), '1', 1, 'R', true);
        $pdf->SetX(0);
        $pdf->Cell(60, 2, '', '1', 1, 'R', true);
        $pdf->SetFont('Arial', '', '10');
        $pdf->SetTextColor(0);
        $pdf->SetX(0);
        $pdf->Cell(60, 6, 'FECHA '.$factura->getFechaFactura(), '', 1, 'R');

        $pdf->Ln(1);
        $pdf->SetTextColor(0);
        $pdf->SetDrawColor(0);
        $pdf->SetFont('Arial', 'B', '8');
        $pdf->cell(100, 4, 'FACTURADO A:', '', 0, 'L');
        $pdf->Cell(20, 4, "", '', 0, 'C'); //<== margin left
        $pdf->cell(98, 4, 'EXPEDIDO EN:', '', 1, 'L');

        $pdf->SetFont('Arial', '', '7');
        $pdf->Cell(120, 4, $cliente->getRazonSocial(), '0', 0, 'L');
        $pdf->Cell(80, 4, utf8_decode($sucursal->getNombre()), '0', 1, 'L');

        $pdf->Cell(120, 4, $cliente->getRFC(), '0', 0, 'L');
        $pdf->Cell(80, 4, utf8_decode($sucursal->getCalle())." ".$sucursal->getNumExterior()." ".$sucursal->getNumInterior(), '0', 1, 'L');

        $pdf->Cell(120, 4, "USO CFDI: ".$factura->getUsoCFDI()." - ".$factura->getUsoCFDINombre(), '0', 0, 'L');
        $pdf->Cell(80, 4, utf8_decode($sucursal->getColonia())." ".$sucursal->getCodigoPostal(), '0', 1, 'L');

        $pdf->Cell(120, 4, utf8_decode($cliente->getCalle())." ".$cliente->getNumExterior()." ".$cliente->getNumInterior(), '0', 0, 'L');
        $pdf->Cell(80, 4, utf8_decode($sucursal->getCiudad())." ".$sucursal->getEstado(), '0', 1, 'L');

        $pdf->Cell(120, 4, utf8_decode($cliente->getColonia())." ".$cliente->getCodigoPostal(), '0', 1, 'L');
        //exit;
        
        $cuentaDeGastos = $factura->getFacturaDetallesSaved($idFactura);
        if ($cuentaDeGastos) {
            $totalCuentaDeGastos = 0;
            $pdf->Ln(1);
            $pdf->SetFont('Arial', 'B', '6');
            $pdf->Cell(165, 5, "DESCRIPCION", 'B', 0, 'L');
            $pdf->Cell(15, 5, "TOTAL", 'B', 1, 'R');

            $pdf->SetFont('Arial', '', '6');
            foreach ($cuentaDeGastos as $gasto) {
                $totalCuentaDeGastos += $gasto['precio_unitario'];
                $pdf->Cell(165, 7, $gasto['nombre']."\n".$gasto['descripcion'], 'B', 0, 'L');
                $pdf->Cell(15, 7, "$".number_format($gasto['precio_unitario'], 2), 'B', 1, 'R');
            }


            $pdf->SetFont('Arial', 'B', '6');
            $pdf->Cell(165, 5, "TOTAL", '', 0, 'R');

            $pdf->SetFont('Arial', '', '6');
            $pdf->Cell(15, 5, "$".number_format($totalCuentaDeGastos, 2), '', 1, 'R');
        }
       

        $pdf->SetFont('Arial', 'B', '6');
        $pdf->Cell(35, 4, 'METODO DE PAGO:', '0', 0, 'L');
        $pdf->SetFont('Arial', '', '6');
        $pdf->Cell(135, 4, $factura->getMetodoDePago()." - ".$factura->getMetodoDePagoNombre(), '0', 1, 'L');

        $pdf->SetFont('Arial', 'B', '6');
        $pdf->Cell(35, 4, 'FORMA DE PAGO:', '0', 0, 'L');

        $pagoConTarjeta = null;
        $salto = 1;
        if ($factura->getFormaDePago() == '04') {
            $salto = 0;
            $pagoConTarjeta = true;
        }

        $pdf->SetFont('Arial', '', '6');
        $pdf->Cell(135, 4, $factura->getFormaDePago()." - ".utf8_decode($factura->getFormaDePagoNombre()), '0', $salto, 'L');

        if ($pagoConTarjeta) {
            $pdf->SetFont('Arial', 'B', '6');
            $pdf->Cell(25, 4, 'NUM DE CUENTA:', '0', 0, 'L');
            $pdf->SetFont('Arial', '', '8');
            $pdf->Cell(25, 4, $factura->getNumCuentaPago(), '0', 1, 'L');
        }

        $pdf->SetFont('Arial', 'B', '6');
        $pdf->Cell(35, 4, 'IMPORTE CON LETRA:', '0', 0, 'L');
        $numeroALetra = new NumeroALetra();
        $pdf->SetFont('Arial', '', '6');
        $pdf->Cell(135, 4, $numeroALetra->numALetras($totalCuentaDeGastos), '0', 1, 'L');

        $pdf->SetFont('Arial', 'B', '6');
        $pdf->Cell(35, 4, 'MONEDA:', '0', 0, 'L');
        $pdf->SetFont('Arial', '', '6');
        $pdf->Cell(135, 4, $factura->getMoneda()." - ".$factura->getMonedaNombre(), '0', 1, 'L');

        if (trim($factura->getComentarios()) != '') {
            $pdf->MultiCell(160, 5, ($factura->getComentarios()), 'TB', 1);
            $pdf->ln(2);
        }

        if ($createFile) {
            if (!is_dir(PATH_SAT_DOCS.$factura->getSucursal()."/temp-pdf/")) {
                mkdir(PATH_SAT_DOCS.$factura->getSucursal()."/temp-pdf/", 0777, true);
            }
            $pdf->Output(PATH_SAT_DOCS.$factura->getSucursal()."/temp-pdf/Factura-".$factura->getSerie()."-".$factura->getFolio().".pdf", "F");
            $this->pathfFileCreated = PATH_SAT_DOCS.$factura->getSucursal()."/temp-pdf/Factura-".$factura->getSerie()."-".$factura->getFolio().".pdf";
        } else {
            $pdf->Output();
        }
    }
    
    public function getPathFileCreated()
    {
        return $this->pathfFileCreated;
    }
}
