<?php

class CustomerAddressRepository extends EntityRepository
{
    private $table = 'customer_addresses';
    private $flashmessenger = null;
    private $options = array(
        'type'=>null,
        'customer_id' => null,
        'alias' => null,
        'address' => null,
        'state' => null,
        'city' => null,
        'zipcode' => null,
        'contact' => null,
        'email' => null,
        'phone' => null,
        'fax'=>null,
        'status'=>null
     );
    
    public function __construct()
    {
        if (!$this->flashmessenger instanceof FlashMessenger) {
            $this->flashmessenger = new FlashMessenger();
        }
    }

    public function _getTranslation($text)
    {
        return $this->flashmessenger->_getTranslation($text);
    }
    
    public function setOptions($data)
    {
        foreach ($this->options as $option => $value) {
            if (isset($data[$option])) {
                $this->options[$option] = $data[$option];
            }
        }
    }
  
    public function getOptions()
    {
        return $this->options;
    }
    
    public function getTable()
    {
        return $this->table;
    }

    public function save(array $data, $table = null)
    {
        return parent::save($data, $this->table);
    }

    public function update($id, $data, $table = null)
    {
        return parent::update($id, $data, $this->table);
    }

    public function getById($id, $table = null, $selectAux = null)
    {
        $select = "SELECT * FROM $this->table WHERE id = '$id'";
        $result = $this->query($select);

        if ($result->num_rows>0) {
            $set = $this->resultToArray($result);
            return $set[0];
        }
        return false;
    }
    
    public function delete($id, $table = null)
    {
        if ($this->isUsedInRecord($id) != null) {
            $this->flashmessenger->addMessage(array('danger'=>'Direccion no se puede eliminar, esta siendo utilzada en almenos un registro.'));
            return null;
        }
        return parent::delete($id, $this->table);
    }

    public function isUsedInRecord($id, array $buscarEn = null, $andWhere= null)
    {
        return parent::isUsedInRecord($id, array('shipping_request'=>'shipping_address','shipping_request'=>'billing_address'));
    }
    
    public function getListSelectShippingAddress($customerId)
    {
        $query = "SELECT * FROM $this->table WHERE customer_id = '$customerId' AND status = '1' ORDER BY alias ASC";
        $result = $this->query($query);
        
        if ($result->num_rows > 0) {
            $result = $this->resultToArray($result);
            $array = array();
            foreach ($result as $row) {
                $array[$row['id']] = $row['alias'].'{*}'.$row['address'].', '.$row['city'].', '.$row['state'].' '.$row['zipcode'];
            }
            
            return $array;
        }
        return null;
    }
    
    public function getListAddress($customerId, $type)
    {
        $select = "SELECT *,"
                . "fxGetCustomerName(customer_id)as customerName,"
                . "IF(type='billing',fxGetStatusName(status,'CustomerBillingAddress'),IF(type='shipping',fxGetStatusName(status,'CustomerShippingAddress'),''))as statusName "
                . "FROM $this->table "
                . "WHERE customer_id = '$customerId' AND `type` = '$type' ";
        $result = $this->query($select);

        if ($result) {
            return $this->resultToArray($result);
        }
        return null;
    }
    
    public function _setCustomerShippingAddresAsDefault($options)
    {
        $query = "UPDATE $this->table SET main_address = '0' WHERE customer_id = '{$options['customer_id']}'";
        $result = $this->query($query);
        
        if ($result) {
            $query = "UPDATE $this->table SET main_address = '1' WHERE customer_id = '{$options['customer_id']}' AND id = {$options['id']}";
            $this->query($query);
        }
        
        return true;
    }
    
    public function getCustomerShippingAddressDefaultByIdCustomer($customerId)
    {
        $query = "SELECT * FROM $this->table WHERE customer_id = '$customerId' AND main_address = '1' LIMIT 1";
        $result = $this->query($query);

        if ($result->num_rows > 0) {
            return $this->resultToArray($result)[0];
        }
        return null;
    }
    
    public function getListStatus()
    {
        $query = "SELECT * FROM status_code WHERE operation = 'CustomerShippingAddress'";
        $result = $this->query($query);
        
        if ($result->num_rows > 0) {
            $array = array();
            foreach ($result as $status) {
                $array[$status['code']] = $status['description'];
            }
            return $array;
        }
        return null;
    }
}
