<?php
/**
 * Description of CustomerForm
 *
 * @author carlos
 */
class CustomerAddressForm extends Form
{
    public function __construct()
    {
        $this->setActionForm('CustomerAddress.php');
        $this->setName('customerAddress');
        $this->setMethod('post');
        $this->setClass('label-inline');
        parent::__construct();
        $this->init();
    }

    public function init()
    {
        /*
         $this->addElement(array(
            'type' => 'select',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->listCliente(),
            'required'=>true,
        )); */
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'customer_id',
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'type',
        ));
         
        $this->addElement(array(
            'type' => 'text',
            'name' => 'alias',
            'label'=>'Alias',
            'required'=>true
        ));
        

        $this->addElement(array(
            'type' => 'text',
            'name' => 'address',
            'label'=>'Direccion',
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'city',
            'label'=>'Ciudad',
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'state',
            'label'=>'Estado',
            'required'=>true
        ));
        
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'zipcode',
            'label'=>'Codigo postal',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'contact',
            'label'=>'Contacto',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'phone',
            'label'=>'Telefono',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'fax',
            'label'=>'Fax',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'email',
            'label'=>'Email',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions' => $this->getListStatus(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/CustomerAddress.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));
    }
    
    public function listCliente()
    {
        $repository = new CustomerRepository();
        $result = $repository->getListSelectClientes();
        
        if ($result) {
            $array = array(null => 'Seleccionar una opcion...');
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function getListStatus()
    {
        $repository = new CustomerRepository();
        $list = $repository->getListStatus();
         
        $array = array();
        if ($list) {
            foreach ($list as $key => $value) {
                $array[$key] = $value;
            }
        }
        return $array;
    }
}
