<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class Ajax extends EntityRepository
{
    public $flashmessenger = null;
    
    public function __construct()
    {
        if (!$this->flashmessenger instanceof FlashMessenger) {
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function getResponse($request, $options)
    {
        return $this->$request($options);
    }
    
    public function _getTranslation($text)
    {
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function getTranslation($options)
    {
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }
    
    public function setCodigosPostales($options){
        $empresa = new EmpresaRepository();
        $result = $empresa->getListSelectCodigosPostales($options['estado']);
       
        $list = "<option value='0'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        foreach ($result as $key => $value) {
            $list .= "<option value='$key'>".($value)."</option>";
        }
       
        return array(
            'response'=>true,
            'codigosPostales'=>$list
                );
    }
    
    public function setMunicipios($options){
        $empresa = new EmpresaRepository();
        $result = $empresa->getListSelectMunicipios($options['estado']);
       
        $list = "<option value='0'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        foreach ($result as $key => $value) {
            $list .= "<option value='". utf8_encode($key)."'>". utf8_encode($value)."</option>";
        }
       
        return array(
            'response'=>true,
            'municipios'=>$list
                );
    }
    
    public function setColonias($options){
        $empresa = new EmpresaRepository();
        $result = $empresa->getListSelectColonias($options['codigoPostal']);
       
        $list = "<option value='0'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";
        foreach ($result as $key => $value) {
            $list .= "<option value='".($key)."'>".($value)."</option>";
        }
       
        return array(
            'response'=>true,
            'colonias'=>$list
                );
    }
    
    public function getCustomerList($options){
        $customerRepo = new ClienteRepository();
        $customerList = $customerRepo->getListSelectClientes();
        
        $string = '<option value="">'.$this->flashmessenger->_getTranslation('Selccionar una opcion...').'</option>';
        if ($customerList) {
            foreach ($customerList as $key => $value) {
                $string .= "<option value='{$key}'>{$value}</option>";
            }
        }
        
        return array(
            'response'=>true,
            'customerList'=>$string
        );
    }
    
     /*Para Facturacion de tickets en Linea  */
    public function validarTicket($options){
        $data = array();
        foreach($options['options'] as $row){
            $data[$row['name']] = $row['value'];
        }
        
        $ticketEntity = new TicketEntity();
        $ticketEntity->setOptions($data);
        $datosTicket = $ticketEntity->getDatosTicket();
        //var_dump($datosTicket);exit;
        if($datosTicket['status']=='1'){
            $this->flashmessenger->addMessage(array('success'=>"Este ticket ya fue facturado.\nPuede descargarlo la factura desde <a href='assets/descargarFactura.php?id={$datosTicket['idFactura']}'>aqui</a>"));
            return array(
                'response'=>true,
                'status'=>$datosTicket['status'],
                'msg'=>$this->flashmessenger->getMessageString()   
            );
        }
        
        if($datosTicket){         
           return array(
                'response'=>true,
                'id_ticket_table'=>$datosTicket['id'],
                'status'=>$datosTicket['status']
            );
        }
        
        /*TICKETS INGRESADOS MANUALMENTE*/
        /*Ingresados maualmente significa que cuando intentaron facturar el ticket, el ticker no estaba en la tbl tickets*/
        /*Aqui hacemos validaciones y si se cumplen insertamos el ticket ingresado para forzar la facturacion del ticket */
        $is_valid = true;
        
        /*VALIDAR TICKET*/
        $ticket = trim((string)$data['ticket']);
        
        /*validar que ticket tenga valor*/
        if($ticket == ''){
            $is_valid = null;            
        }else{            
            /*validar que ticket este entre 100 y 9999*/
            if((int)$ticket < 100 || (int)$ticket > 10000){$is_valid = null;}
        }
        
        /*VALIDAR TOTAL*/
        if((float)$data['total'] > 600){$is_valid = null;}
        
        /*VALIDAR FECHA*/
        $ticketDate = new DateTime($data['fecha']);
        $currentDate = new DateTime(date('Y-m-d'));
        $currentDate->sub(new DateInterval('P7D'));
        
        /*Fecha de ticket debe ser mayor a hoy menos 1 dias; es decir no puede ser mas viejo que una semana*/
        if($ticketDate < $currentDate){$is_valid = null;}       
        
        /*Si se cumplen las validaciones se inserta ticket*/
        if($is_valid){
            $subtotal = $data['total']/1.16;
            $subtotal = round($subtotal,2);
            $iva = (float)$data['total'] - $subtotal;
            
            $array = array(
                'noticket'=>$data['ticket'],
                'nosucursal'=>$data['sucursal'],
                'fecha'=>$data['fecha'],
                'subtotal'=>$subtotal,
                'iva'=>$iva,
                'neto'=>$data['total'],
                'status'=>0,              
                'agregado_manual'=>1
            );
            
            if($this->ya_se_inserto_manual == null){
                $ticketEntity->save($array);     
                $this->ya_se_inserto_manual = true;

                /*Despues de insertar ticket, volvemos mandar llamar la funcions para que ahora si se pueda facturar*/
                return $this->validarTicket($options);
               
            }else{
                /*Algo ocurrio, y no encontro el ticket que se registro manualmente, marcamos este error para que no se siga insertando infinitamente*/
                $this->flashmessenger->addMessage(array('danger'=>'A ocurrido un error inesperado al procesar su solicitud, por favor intente mas tarde. El codigo de error 0x0000802.'));
                return array(
                    'response'=>null,
                    'error'=>true,
                    'msg'=>$this->flashmessenger->getMessageString()   
                );
            }
           
        }else{
            /*Si no se cumplen, manda un mensaje de error*/
            $this->flashmessenger->addMessage(array('danger'=>'A ocurrido un error inesperado al procesar su solicitud, por favor intente mas tarde. El codigo de error 0x0000801.'));
            return array(
                'response'=>null,
                'error'=>true,
                'msg'=>$this->flashmessenger->getMessageString()   
            );
        }
        
       $this->flashmessenger->addMessage(array('info'=>'Lo sentimos =( No se encontraron resultados con la informacion ingresada.'));
        return array(
                'response'=>null,
                'msg'=>$this->flashmessenger->getMessageString()   
           );
    }
    
    public function getDomiciliosFiscalesByRFC($options){        
        $clienteRepo = new ClienteRepository();
        $listClientes = $clienteRepo->getDomiciliosFiscalesByRFC($options['rfc']);
        
        $string = "";
        if($listClientes){
            foreach($listClientes as $cliente){
                $cliente['id_cliente'] = $cliente['id'];
                $array = json_encode($cliente);
                $string .= "<tr>";                
                $string .= "<td class='text-center'>{$cliente['razon_social']}</td>";
                $string .= "<td class='text-center'>{$cliente['codigo_postal']}</td>";      
                $string .= "<td class='text-center'>{$cliente['pais']}</td>";
                $string .= "<td class='text-center'>{$cliente['estado']}</td>";
                $string .= "<td class='text-center'>{$cliente['ciudad']}</td>";
                $string .= "<td class='text-center'>{$cliente['colonia']}</td>";
                $string .= "<td class='text-center'>{$cliente['calle']}</td>";
                $string .= "<td class='text-center'>{$cliente['numero_exterior']}</td>";
                $string .= "<td class='text-center'>{$cliente['numero_interior']}</td>";
                $string .= "<td><a class='btn btn-md btn-default' onclick='setDomicilioFiscalToEdit($array);$(\"#modalListaDomiciliosPorRFC\").modal(\"hide\")'><i class='fa fa-map-marker'></i></a></td>";
                $string .= "</tr>";
            }
            
            return array(
                'response'=>true,
                'domiciliosFiscales'=>$string
            );
        }else{
            return array(
                'response'=>null
            );
        }
    }
    
    public function facturarTicket($options){
        $data = array();
        foreach($options['options'] as $row){
            $data[$row['name']] = $row['value'];
        }
        
        /*Ingresados maualmente significa que cuando intentaron facturar el ticket, el ticker no estaba en la tbl tickets*/
        /*Validamos que RFC no facture mas de dos tickets ingresados manualmente*/
        $ticketRepository  = new TicketRepository();
        $ticketsFacturados = $ticketRepository->getTicketAgregadoManualTodayByIdCliente($data['id_cliente']);        
        
        /*Un RFC solo puede facturar dos ticker ingresados manualmente*/
        if($ticketsFacturados && $ticketsFacturados > 1){
            $this->flashmessenger->addMessage(array('danger'=>'A ocurrido un error inesperado al procesar su solicitud, por favor intente mas tarde. El codigo de error 0x0000801.'));
            return array(
                'response'=>null,
                'error'=>true,
                'msg'=>$this->flashmessenger->getMessageString()   
            );
        }
        
        $ticket = new TicketEntity();
        $idFactura = $ticket->facturarTicket($data);
        
        $facturar = new FacturarRepository($idFactura,'Factura');
        if($facturar->_timbrar()){
            $invoice = new FacturaRepository();
            $invoice->setOptions($invoice->getById($idFactura));
            $invoice->setId($idFactura);            
            
            $fields = array(
                'idFactura'=>$idFactura,
                'idCliente'=>$invoice->getIdCliente(),
                'metodoPago'=>$invoice->getFormaDePago(),
                'numCtaPago'=>$invoice->getNumCuentaPago(),
                'status'=>'1');
            
            $ticket->update($data['id_ticket_table'],$fields);

            $invoice->crearPDF();
            $zipFile = $invoice->crearZip();

            try{
                $emailer = new Emailer();
                $emailer->sendEmail(array(
                    'to'=>$data['email'],
                    'subject'=>'Factura - '.$invoice->getNumFactura(),
                    'message'=>'Revisar factura adjunta',
                    'attachment'=>$zipFile
                ));

                $this->flashmessenger->addMessage(array('success'=>'Genial!! La Factura se envio correctamente.'));
                
            } catch (Exception $ex) {
                $this->flashmessenger->addMsg(array('danger'=>'Oops =(. Algo salio mal al tratar de enviar la Factura.'));
            }        
            
            $response = true;
            $msg = $this->flashmessenger->getMessageString();   
            $step_factura_content = "<div style='width:50%;margin:auto;text-align:center'><a href='assets/descargarFactura.php?id=$idFactura' class='btn btn-primary' target='iframe'><i class='fa fa-download'></i> Descarga tu factura aqui</a></div>";
            
        }else{
            /*Aqui deberie eliminar factura que no se pudo timbrar para no generar basura*/
            $response = null;
            $msg = $this->flashmessenger->getMessageString();
            $step_factura_content = '';
        }
        
        return array(
            'response'=>$response,
            'msg'=>$msg,
            'step_factura_content'=>$step_factura_content
        );
        
    }    
     /*FIN Para Facturacion de tickets en Linea  */
}
